//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Security.Permissions;

namespace Bon
{
	/// <summary>
	/// BonSDKŔONXłB
	/// </summary>
	[Serializable]
	[ComVisible(true)]
	[Guid("330ADCAE-013D-4995-8542-A7FCB999B439")]
	[ComDefaultInterface(typeof(_Exception))]
	public class BonException : Exception
	{
		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="format">ObZ[W̃tH[}bg</param>
		/// <param name="args">ǉQ</param>
		public BonException(string format, params object[] args)
			: base(string.Format(format, args))
		{
		}

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="inner">O</param>
		/// <param name="format">ObZ[W̃tH[}bg</param>
		/// <param name="args">ǉQ</param>
		public BonException(Exception inner, string format, params object[] args)
			: base(string.Format(format, args), inner)
		{
		}

		/// <summary>
		/// tVARXgN^łB
		/// </summary>
		/// <param name="info">VA</param>
		/// <param name="context">Xg[ReLXg</param>
		/// <remarks>NXpꍇ́ÃRXgN^GetObjectDataI[o[ChKv܂B</remarks>
		[SecurityPermission(SecurityAction.Demand, SerializationFormatter = true)]
		protected BonException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
