//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	/// <summary>
	/// Xg[EPG𒊏ۉC^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("9A790CF4-114D-497d-9249-25EA8468FB2D")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IEpgData
	{
		/// <summary>
		/// Ɏ擾\ȃvpeBl擾܂B
		/// </summary>
		EpgDataStates EpgDataStatus
		{
			get;
		}

		///////////////////////////////
		// EventIDStored ŗL

		/// <summary>
		/// CxgID擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		int EventID
		{
			get;
		}

		/// <summary>
		/// Jn擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		DateTime StartTime
		{
			get;
		}

		/// <summary>
		/// Xg[̎ԊԊu擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		TimeSpan Duration
		{
			get;
		}

		/// <summary>
		/// XNuĂ邩ǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusEventIDStoredĂKv܂B</remarks>
		bool IsScrambled
		{
			get;
		}

		///////////////////////////////
		// ShortInfoStored ŗL

		/// <summary>
		/// Cxg^Cg擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusShortInfoStoredĂKv܂B</remarks>
		string EventTitle
		{
			get;
		}

		/// <summary>
		/// Cxg擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusShortInfoStoredĂKv܂B</remarks>
		string EventInfo
		{
			get;
		}

		///////////////////////////////
		// ExtendInfoStored ŗL

		/// <summary>
		/// Cxg̏ڍׂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusExtendInfoStoredĂKv܂B</remarks>
		string EventDetail
		{
			get;
		}

		///////////////////////////////
		// VideoInfoStored ŗL

		/// <summary>
		/// f̑擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		int VideoResolution
		{
			get;
		}

		/// <summary>
		/// fvObVuǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		bool IsVideoProgressive
		{
			get;
		}

		/// <summary>
		/// fCh䗦ǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		bool IsVideoAspectWide
		{
			get;
		}

		/// <summary>
		/// fpXLĂ邩ǂ擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusVideoInfoStoredĂKv܂B</remarks>
		bool IsVideoPanAndScan
		{
			get;
		}

		///////////////////////////////
		// AudioInfoStored ŗL

		/// <summary>
		/// ̏擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusAudioInfoStoredĂKv܂B</remarks>
		AudioModes AudioMode
		{
			get;
		}

		///////////////////////////////
		// ContentInfoStored ŗL

		/// <summary>
		/// W擾܂B
		/// </summary>
		/// <remarks>l擾ɂ́AEpgDataStatusContentInfoStoredĂKv܂B</remarks>
		int Genre
		{
			get;
		}

		int GetGenreLevel1(int index);
		int GetGenreLevel2(int index);
	}
}
