//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Net;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// `[i[𒊏ۉC^[tFCXłB
	/// </summary>
	/// <remarks>`[i[̐ɕKvȃ\bh`Ă܂B
	/// Xg[f[^̂̓[gQƂłׂ͕傫邽߁AʌɐڑKv܂B
	/// ̃C^[tFCXgpāA`[i[bN邱Ƃ͏o܂B</remarks>
	[ComVisible(true)]
	[Guid("F7A12C71-032C-4188-B118-5925F618097F")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IRemoteTuner
	{
		/// <summary>
		/// ̃`[i[M\ȃ`[jOXy[Xƃ`l̏擾܂B
		/// </summary>
		/// <returns>`[jOXy[XQ</returns>
		IRemoteTuningSpaceInformation[] GetTuningSpaces();

		/// <summary>
		/// ftHg̃vC[vOւ̃pX擾܂B
		/// </summary>
		/// <param name="architectureName">A[LeN`</param>
		/// <remarks>A[LeN`̓Xg[T[rXŒ`܂AftHgňȉ̖O`Ă܂B
		/// <para>"Windows-INTEL": Windows x86vbgtH[</para>
		/// <para>"Windows-AMD64": Windows x64vbgtH[</para>
		/// ꂽpXɂ́AϐWJL[[h܂܂Ă\܂B
		/// "%ProgramFiles%"̂悤Ȍ`łB
		/// .NET Frameworkł́ASystem.Environment.ExpandEnvironmentVariablesgpēWJ܂B</remarks>
		string GetDefaultPlayerPath(string architectureName);

		/// <summary>
		/// ݂̃`[i[̏Ԃ擾܂B
		/// </summary>
		/// <returns>`[i[̏</returns>
		IRemoteTunerStatus GetTunerStatus();

		/// <summary>
		/// ݎMĂEPG擾܂B
		/// </summary>
		/// <returns>EPGQ</returns>
		IRemoteProgramInformation[] GetPrograms();

		/// <summary>
		/// J[hɑ΂EMMKp邩ǂݒ肵܂B
		/// </summary>
		/// <param name="enable">EMMsꍇtrue</param>
		/// <remarks>`[i[bNĂꍇ͎s܂B</remarks>
		void SetEmmProcess(bool enable);

		/// <summary>
		/// `[i[ɐڑĂAeipLNBdL邩ǂݒ肵܂B
		/// </summary>
		/// <param name="enable">LNBdLꍇtrue</param>
		/// <remarks>`[i[bNĂꍇ͎s܂B</remarks>
		void SetLnbPower(bool enable);

		/// <summary>
		/// ̃`[i[̃`[jOXy[Xƃ`lݒ肵܂B
		/// </summary>
		/// <param name="tuningSpace">`[jOXy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="programID">vOID</param>
		/// <remarks>`[i[bNĂꍇ͎s܂B
		/// `[i[ɐڑ̑SẴXg[́AIɎw肳ꂽvOIDɕύX܂
		/// iAA`[jOXy[Xƃ`lɕύXȂꍇ͖܂jB
		/// vOIDƂ-1w肷ƁASẴXg[f[^M܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IđM܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B</remarks>
		void SetChannel(int tuningSpace, int channel, int programID);

		/// <summary>
		/// w肳ꂽNCAgGh|CgMĂvOID擾܂B
		/// </summary>
		/// <param name="endPoint">NCAgGh|Cg</param>
		/// <returns>vOID</returns>
		int GetProgramID(IPEndPoint endPoint);

		/// <summary>
		/// w肳ꂽNCAgGh|CgMvOIDݒ肵܂B
		/// </summary>
		/// <param name="endPoint">NCAgGh|Cg</param>
		/// <param name="programID">vOID</param>
		/// <remarks>vOIDƂ-1w肷ƁASẴXg[f[^M܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IđM܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B</remarks>
		void SetProgramID(IPEndPoint endPoint, int programID);

		/// <summary>
		/// w肳ꂽNCAgGh|CgIɐؒf܂B
		/// </summary>
		/// <param name="endPoint">NCAgGh|Cg</param>
		/// <remarks>NCAgGh|CgȂꍇ͖܂B</remarks>
		void DisconnectStream(IPEndPoint endPoint);
	}
}
