//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Bon
{
	public partial class ExceptionForm : Form
	{
		public ExceptionForm(Exception ex)
		{
			InitializeComponent();

			errorPictureBox.Image = SystemIcons.Error.ToBitmap();
			base.Text = ex.GetType().FullName;
			messageTextBox.Text = ex.Message;
			detailPropetyGrid.SelectedObject = ex;
		}
	}
}