//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// BonObject.cpp: x[XC^tF[XNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "BonObject.h"
#include <TChar.h>


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// BonIuWFNgC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

void CBonObject::Release(void)
{
	// CX^XJ
	delete this;
}

const BONGUID CBonObject::GetGuid(void) const
{
	// NXԂ
	return TypeToGuid(typeid(CBonObject));
}

CBonObject::CBonObject(IBonObject *pOwner)
	: m_pOwner(pOwner)
{
	// Ȃ
}

CBonObject::~CBonObject(void)
{
	// Ȃ
}

IBonObject * CBonObject::CreateInstance(IBonObject *pOwner)
{
	// CX^X
	return reinterpret_cast<IBonObject *>(new CBonObject(pOwner));
}

const BONGUID CBonObject::TypeToGuid(const type_info &TypeID)
{
	// GUIDԂ
	return ::BON_NAME_TO_GUID(CBonString(&TypeID.name()[6]));
}

}
