//////////////////////////////////////////////////////////////////////////
// BonSDK Media decoder library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// TsSourceTuner.h: TS\[X`[ifR[_
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// TS\[X`[ifR[_
/////////////////////////////////////////////////////////////////////////////
// Output	#0	: IMediaData	TSXg[
/////////////////////////////////////////////////////////////////////////////

// IHalTsTuner ̎́AInputMedia Ăяo TSXg[f[^𑗐M
// B̃NX CQueuedMediaDecoder pĂ邽߁AɃf[^
// L[ɕێAʃXbhgpăf[^ʂ̃fR[_ɑMB
class CTsSourceTuner :	public CQueuedMediaDecoder,
						public ITsSourceTuner
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CTsSourceTuner)

// ITsSourceTuner
	virtual const DWORD OpenTuner(LPCTSTR lpszBCId);
	virtual const bool CloseTuner(void);
	virtual const CBonString GetDeviceName() const;
	virtual const DWORD GetDeviceID(void) const;
	virtual const CBonString GetTuningSpaceName(const DWORD dwSpace) const;
	virtual const CBonString GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const;
	virtual const DWORD GetCurSpace(void) const;
	virtual const DWORD GetCurChannel(void) const;
	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	virtual const bool SetLnbPower(const bool bEnable);
	virtual const float GetSignalLevel(void) const;
	
// CTsSourceTuner
	CTsSourceTuner(IBonObject *pOwner, IMediaDataHeap *pHeap = new CMediaDataHeap());
	virtual ~CTsSourceTuner(void);
	
protected:
// CMediaDecoder
	virtual const bool OnPlay(void);
	virtual const bool OnStop(void);
	virtual const bool OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex);

private:
// CTsSourceTuner
	IHalTsTuner *m_pHalTsTuner;

	bool m_bIsPlaying;
};
