//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	namespace Internal
	{
		template <typename T> T *CreateBonInstance(LPCTSTR pClassName, IBonObject *pOwner = 0)
		{
			T *pInstance = BON_SAFE_CREATE<T *>(pClassName, pOwner);
			if (pInstance == 0)
			{
				throw gcnew BonException("Cannot create instance: Name={0}",
					gcnew System::String(pClassName));
			}
			return pInstance;
		}
	}
}
