//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Bon
{
	public partial class AddStreamServiceForm : Form
	{
		public AddStreamServiceForm(StringCollection addStreamServiceHistory)
		{
			InitializeComponent();

			if (addStreamServiceHistory != null)
			{
				foreach (string url in addStreamServiceHistory)
				{
					urlComboBox.Items.Add(url);
				}
			}
		}

		public Uri Url
		{
			get
			{
				return new Uri(urlComboBox.Text);
			}
		}
	}
}