//////////////////////////////////////////////////////////////////////////
// BonSDK Media decoder library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// MediaGrabber.h: fBAOofR[_
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// fBAOofR[_
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: IMediaData	oCiXg[
// Output	#0	: IMediaData	oCiXg[
/////////////////////////////////////////////////////////////////////////////

class CMediaGrabber :	public CMediaDecoder,
						public IMediaGrabber
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CMediaGrabber)

// CMediaGrabber
	CMediaGrabber(IBonObject *pOwner);
	virtual ~CMediaGrabber(void);
	
protected:
// CMediaDecoder
	virtual const bool OnPlay(void);
	virtual const bool OnStop(void);
	virtual const bool OnReset(void);
	virtual const bool OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex = 0UL);
};
